; FloatmotionInstaller.nsi
;
; This is the NSIS installer script of my game Floatmotion

;--------------------------------

!ifdef HAVE_UPX
!packhdr tmp.dat "upx\upx -9 tmp.dat"
!endif

!ifdef NOCOMPRESS
SetCompress off
!endif

;--------------------------------

Name "Floatmotion"
Caption "Floatmotion - Nico Bosshard"
Icon ".\Data\img\FM_Icon.ico"
OutFile "FloatmotionSetup.exe"
SetCompressor LZMA

SetDateSave on
SetDatablockOptimize on
CRCCheck on
SilentInstall normal
BGGradient 000000 800000 FFFFFF
InstallColors 80FF80 000030
XPStyle on

InstallDir "$PROGRAMFILES\Floatmotion"
InstallDirRegKey HKLM "Software\Floatmotion" "Install_Dir"

CheckBitmap "${NSISDIR}\Contrib\Graphics\Checks\classic-cross.bmp"

LicenseText "Floatmotion is a free open source software from Nico Bosshard made for a school project"
LicenseData "LICENSE"

RequestExecutionLevel admin

;--------------------------------

Page license
Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

!ifndef NOINSTTYPES ; only if not defined
  InstType "Normal"
  InstType "Full"
  InstType "Base"
  ;InstType /NOCUSTOM
  ;InstType /COMPONENTSONLYONCUSTOM
!endif

AutoCloseWindow true
ShowInstDetails show


;--------------------------------

Section "" ; empty string makes it hidden, so would starting with -
  SetOutPath $INSTDIR
  
  ReadRegStr $0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion" "Path"
  StrCmp $0 "" +5 0
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion"
  DeleteRegKey HKLM "SOFTWARE\Floatmotion"
  Delete "$DESKTOP\Floatmotion.lnk"
  Delete "$SMPROGRAMS\Floatmotion.lnk"
  RMDir /r "$INSTDIR"
  
  
  File /r /x FloatmotionSetup.exe *
  
  #System::Call 'user32::GetSystemMetrics(i 0) i .r0'
  #System::Call 'user32::GetSystemMetrics(i 1) i .r1'
  #MessageBox MB_OK|MB_ICONINFORMATION "Screen Resolution: $\r$\n$0 X $1"
  

  ; write reg info
  WriteRegStr HKLM SOFTWARE\Floatmotion "Install_Dir" "$INSTDIR"

  ; write uninstall strings
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion" "DisplayName" "Floatmotion (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion" "UninstallString" '"$INSTDIR\Uninstall.exe"'

  
  WriteUninstaller "Uninstall.exe"
SectionEnd


SectionGroup /e "Shortcuts"
Section "Desktop"
  SectionIn 1 2

  SetOutPath $INSTDIR ; for working directory
  CreateShortcut "$DESKTOP\Floatmotion.lnk" "$INSTDIR\Floatmotion_LM.exe" "" "$INSTDIR\Data\img\FM_Icon.ico" 0 SW_SHOWMINIMIZED
SectionEnd


Section "Startprograms"
  SectionIn 1 2

  SetOutPath $INSTDIR ; for working directory
  CreateShortcut "$SMPROGRAMS\Floatmotion.lnk" "$INSTDIR\Floatmotion_LM.exe" "" "$INSTDIR\Data\img\FM_Icon.ico" 0 SW_SHOWMINIMIZED
SectionEnd
SectionGroupEnd


Section "Open Help file after setup"
  SectionIn 1 2
  ExecShell "open" '"$INSTDIR\Help.mht"'
SectionEnd


Section "Start Floatmotion after setup"

  SectionIn 1 2

  #Exec '"$INSTDIR\Floatmotion_LM.exe"'
  Sleep 250
  ExecShell "open" '"$INSTDIR\Floatmotion_LM.exe"'
  #ExecShell "open" '"$INSTDIR"'
SectionEnd


Section "" ; empty string makes it hidden, so would starting with -
  SetOutPath $INSTDIR
  WriteUninstaller "Uninstall.exe"

  ; write reg info
  WriteRegStr HKLM SOFTWARE\Floatmotion "Install_Dir" "$INSTDIR"

  ; write uninstall strings
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion" "DisplayName" "Floatmotion (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion" "UninstallString" '"$INSTDIR\Uninstall.exe"'
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion" "Path" '"$INSTDIR"'
SectionEnd




;--------------------------------

; Uninstaller

UninstallText "This will uninstall Floatmotion. Hit next to continue."
UninstallIcon "${NSISDIR}\Contrib\Graphics\Icons\nsis1-uninstall.ico"

Section "Uninstall"

  MessageBox MB_YESNO|MB_ICONQUESTION "Are you sure to completely uninstall Floatmotion from your computer?" IDNO NoDelete
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Floatmotion"
  DeleteRegKey HKLM "SOFTWARE\Floatmotion"
  Delete "$DESKTOP\Floatmotion.lnk"
  Delete "$SMPROGRAMS\Floatmotion.lnk"
  RMDir /r "$INSTDIR"

  IfFileExists "$INSTDIR" 0 NoErrorMsg
    MessageBox MB_OK "Note: $INSTDIR could not be removed! Please delete it manually." IDOK 0 ; skipped if file doesn't exist

  NoErrorMsg:
  NoDelete:

SectionEnd
