﻿"""
 A simple Game nemed Flootmoion
 Developed by NicoBosshard <nico@bosshome.ch>

 http://www.nicobosshard.ch
"""

import sys, os
Plugins_path=os.path.abspath('./Plugins/')
sys.path.append(Plugins_path)

from tendo import singleton
me = singleton.SingleInstance() # will sys.exit(-1) if other instance is running

import math, pygame, random, time, webbrowser, shutil #Some usual Libary staff. shutil is used for restoring the config file.
try:
    import Leap
    from Leap import CircleGesture, KeyTapGesture, ScreenTapGesture, SwipeGesture #Leap Motion a movment control system
    from pygame.locals import * #pygame is a Game Engine like SDL2 for Python but probably better than pySDL2
    Leap_available = True
except ImportError:
    print "Couldn't load the Leap Motion libaries"
    print "Have you installed the Leap Motion Setup from https://www.leapmotion.com/setup yet?"
    Leap_available = False

from OpenGL.GL import * #OpenGL the best grafic libary ever!
from OpenGL.GLU import * #And other pyOpenGL staff
from OpenGLLibrary import * #A GameEngine that I have downloaded and modified I also added some Functions to it and fixed bugs.
#import main #To get the main.pyc file.

import Tkinter as tk #import tkinter in Python 3
import tkMessageBox
import pygubu

Version="Floatmotion_PC_2.1.6_Windows"
PublishDate="01.07.2015"
Programmer="Nico Bosshard"
EMail="nico@bosshome.ch"

#Set the background soundpPaths
print "Loading sounds"
Sound=["./Data/sound/Sound1.mp3","./Data/sound/Sound2.mp3","./Data/sound/Sound3.mp3"]
Sound_GameOver="./Data/sound/GameOver.mp3"
Sound_LevelUp="./Data/sound/LevelUp.mp3"
Sound_RainbowCube="./Data/sound/RainbowCube.mp3"

#Load sound effects - mp3 doesn't work with pygame.mixer.Sound!
boom = [pygame.mixer.Sound("./Data/sound/Boom1.wav"),pygame.mixer.Sound("./Data/sound/Boom2.wav"),pygame.mixer.Sound("./Data/sound/Boom3.wav")]
GetHeart = pygame.mixer.Sound("./Data/sound/GetHeart.wav")
GetClock = pygame.mixer.Sound("./Data/sound/GetClock.wav")
baem = pygame.mixer.Sound("./Data/sound/Boom1.wav")

#Set the default Values to be independant from a defect config.ini File
Configfile_string=""

Music_volume=100
Effect_volume=100
Stars_amount=400
Particles_factor=1.0
Transparence=150
Lighting=True
Sun_pos_default=[20,200,20]
Camera_pos_default = [0,0.5,6]

Level=1
Level_length=500
Leben=7
Leben_Respawnvalue=7
Tutorial=True

LeapConnected=False
MouseNoKlick=True
EndlessMode=False
EndlessMode_ShowText=0
FastForward=1.0
BackslashL_Active=False
Backquote_Active=False
Shift_Active=False
TurnStatusbar=False
TurnTime=False
TurnFPS=False
more_FPS=False
Tap_Press=False

Leap_Pause_on_disconnect=True
Leap_Hand_out_of_View_Show=True
Leap_Hand_out_of_View_ActivationTime=80
NicoIcon_Show=True

Screen_width=0 #0=auto
Screen_hight=0 #0=auto
Fullscreen=False
Screenshotpath="./"



#Function for loading the config.ini file.
def Load_ConfigFile():
    global Configfile_string
    global Version, PublishDate, Programmer, EMail #[Info]
    global Screenshotpath, INSTDIR, PROFILE, DOCUMENTS, PICTURES, DESKTOP #[Paths]
    global Screen_width, Screen_hight, Fullscreen, more_FPS, Stars_amount, Particles_factor, Lighting, Sun_pos_default, Camera_pos_default #[Graphics]
    global Music_volume, Effect_volume #[Sound]
    global MouseNoKlick #[Scoreboard]
    global EndlessMode, FastForward, Level, Leben_Respawnvalue, Leben, Level_length, Leap_Pause_on_disconnect, Leap_Hand_out_of_View_Show, Leap_Hand_out_of_View_ActivationTime, NicoIcon_Show #[Default]


    with open("config.ini") as f:
        Configfile_string=str(f.read()) #str() is maybe useless
        f.seek(0) #Set the read cursor to the start of the file so that I can read it twice.
        for line in f:
            line=line.replace('\n', "")
            words=line.split('=')

            if(words.__len__()==2):
                if(section=="[Info]"):
                    if(words[0]=="Version"):
                        Version=words[1]
                    if(words[0]=="PublishDate"):
                        PublishDate=words[1]
                    if(words[0]=="Programmer"):
                        Programmer=words[1]
                    if(words[0]=="E-Mail"):
                        EMail=words[1]

                if(section=="[Paths]" and words[0]=="Screenshotpath"):
                    Screenshotpath=words[1]

                if(section=="[Graphics]"):
                    if(words[0]=="Screen_width"):
                        Screen_width=eval(words[1])
                    if(words[0]=="Screen_hight"):
                        Screen_hight=eval(words[1])

                    if(words[0]=="Fullscreen"):
                        if(words[1]=="True"): #Erst wird true geprüft da default
                            Fullscreen=True
                        elif(words[1]=="False"):
                            Fullscreen=False
                        else:
                            print Config_Error_1,line,"Fullscreen",Config_Error_2,"true."
                            Fullscreen=True

                    if(words[0]=="noStars(more_FPS)"):
                        if(words[1]=="False"): #Erst wird false geprüft da default
                            more_FPS=False
                        elif(words[1]=="True"):
                            more_FPS=True
                        else:
                            print Config_Error_1,line,"noStars(more_FPS)",Config_Error_2,"false."
                            more_FPS=False

                    if(words[0]=="Stars_amount"):
                        Stars_amount=eval(words[1])

                    if(words[0]=="Particles_factor"):
                        Particles_factor=eval(words[1])

                    if(words[0]=="Transparence"):
                        Transparence=eval(words[1])

                    if(words[0]=="Lighting"):
                        if(words[1]=="True"): #Erst wird true geprüft da default
                            Lighting=True
                        elif(words[1]=="False"):
                            Lighting=False
                        else:
                            print Config_Error_1,line,"Lighting",Config_Error_2,"false."
                            Lighting=True

                    if(words[0]=="Sun_pos"):
                        Sun_pos_default=map(float,(words[1].replace(' ', '').split(','))) # list(map(float, list)) in Python 3

                    if(words[0]=="Camera_pos"):
                        Camera_pos_default=map(float,(words[1].replace(' ', '').split(','))) # list(map(float, list)) in Python 3

                if(section=="[Scoreboard]"):
                    if(words[0]=="TurnStatusbar"):
                        if(words[1]=="False"): #Erst wird false geprüft da default
                            TurnStatusbar=False
                        elif(words[1]=="True"):
                            TurnStatusbar=True
                        else:
                            print Config_Error_1,line,"TurnStatusbar",Config_Error_2,"false."
                            TurnStatusbar=False

                    if(words[0]=="TurnTime"):
                        if(words[1]=="False"): #Erst wird false geprüft da default
                            TurnTime=False
                        elif(words[1]=="True"):
                            TurnTime=True
                        else:
                            print Config_Error_1,line,"TurnTime",Config_Error_2,"false."
                            TurnTime=False

                    if(words[0]=="TurnFPS"):
                        if(words[1]=="False"): #Erst wird false geprüft da default
                            TurnFPS=False
                        elif(words[1]=="True"):
                            TurnFPS=True
                        else:
                            print Config_Error_1,line,"TurnFPS",Config_Error_2,"false."
                            TurnFPS=False

                if(section=="[Sound]"):
                    if(words[0]=="Music_volume"):
                        Music_volume=eval(words[1][:-1]) # [:-1] is faster than .replace('%' '')
                    if(words[0]=="Effect_volume"):
                        Effect_volume=eval(words[1][:-1]) # [:-1] is faster than .replace('%' '')

                if(section=="[Control]" and words[0]=="MouseNoKlick(mouse Only)"):
                    if(words[1]=="True"): #Erst wird true geprüft da default
                        MouseNoKlick=True
                    elif(words[1]=="False"):
                        MouseNoKlick=False
                    else:
                        print Config_Error_1,line,"MouseNoKlick",Config_Error_2,"true."
                        MouseNoKlick=True

                if(section=="[Default]"):
                    if(words[0]=="EndlessMode"):
                        if(words[1]=="False"): #Erst wird false geprüft da default
                            EndlessMode=False
                        elif(words[1]=="True"):
                            EndlessMode=True
                        else:
                            print Config_Error_1,line,"EndlessMode",Config_Error_2,"false."
                            EndlessMode=False

                    if(words[0]=="FastForward"):
                        FastForward=eval(words[1])

                    if(words[0]=="Level"):
                        Level=eval(words[1])
                        if(Level<0):
                            Level=0
                        elif(Level>10):
                            Level=10

                    if(words[0]=="Lives"):
                        Leben_Respawnvalue=eval(words[1])
                        Leben=Leben_Respawnvalue

                    if(words[0]=="Level_length"):
                        Level_length=eval(words[1])

                    if(words[0]=="Leap_Pause_on_disconnect"):
                        if(words[1]=="True"): #Erst wird true geprüft da default
                            Leap_Pause_on_disconnect=True
                        elif(words[1]=="False"):
                            Leap_Pause_on_disconnect=False
                        else:
                            print Config_Error_1,line,"Leap_Pause_on_disconnect",Config_Error_2,"true."
                            Leap_Pause_on_disconnect=True

                    if(words[0]=="Leap_Hand_out_of_View_Show"):
                        if(words[1]=="True"): #Erst wird true geprüft da default
                            Leap_Hand_out_of_View_Show=True
                        elif(words[1]=="False"):
                            Leap_Hand_out_of_View_Show=False
                        else:
                            print Config_Error_1,line,"Leap_Hand_out_of_View_Show",Config_Error_2,"true."
                            Leap_Hand_out_of_View_Show=True

                    if(words[0]=="Leap_Hand_out_of_View_ActivationTime"):
                        Leap_Hand_out_of_View_ActivationTime=eval(words[1])

                    if(words[0]=="NicoIcon_Show"):
                        if(words[1]=="True"): #Erst wird true geprüft da default
                            NicoIcon_Show=True
                        elif(words[1]=="False"):
                            NicoIcon_Show=False
                        else:
                            print Config_Error_1,line,"NicoIcon_Show",Config_Error_2,"true."
                            NicoIcon_Show=True

                print line.split('=')
            else:
                section=line



#The following function is used for opening the Setting model and to restart my game after finishing configuration
#For the restart a restart_delay.temp file will be created that contains the restart delay time in order to transmit it to the launcher
#After this the launcher will be started and the game closes
def Settings_open():
    global Configfile_string
    pygame.quit()
    pygame.init()
    import settings
    Configfile_string=settings.main(Configfile_string)
    del sys.modules["settings"]
    with open("restart_delay.tmp", "w") as Configfile_write:
        Configfile_write.write("1000")
    webbrowser.open("Floatmotion_LM.exe")
    pygame.quit()
    sys.exit()


def Loading_key():
    key = pygame.key.get_pressed()
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
        if event.type == KEYDOWN:
            if event.key == K_SPACE or event.key == K_RETURN or event.key == K_KP_ENTER:
                Settings_open()
            elif event.key == K_ESCAPE or (event.key == K_F4 and bool(event.mod & KMOD_ALT)):
                pygame.quit()
                sys.exit()


#If the programm doesn't reponse to any Events windows make the Window white and means that the program crashed. Also It's always useful if the exit keys works.
def Cutscene_key():
    key = pygame.key.get_pressed()
    for event in pygame.event.get():
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
        if event.type == KEYDOWN:
            if event.key == K_ESCAPE or (event.key == K_F4 and bool(event.mod & KMOD_ALT)):
                pygame.quit()
                sys.exit()

#A Function to check if a sphere collids with a cube. To uderstand how it works you have to imagine what it does and maybe also draw it on a paper.
def SphereRectCollision(sphere, rect):
    sphereXDistance = abs(sphere.x - rect.x)
    sphereYDistance = abs(sphere.y - rect.y)
    sphereZDistance = abs(sphere.z - rect.z)

    if(sphereXDistance > (rect.size + sphere.radius)): return False
    if(sphereYDistance > (rect.size + sphere.radius)): return False
    if(sphereZDistance > (rect.size + sphere.radius)): return False

    if(sphereXDistance <= (rect.size)): return True
    if(sphereYDistance <= (rect.size)): return True
    if(sphereZDistance <= (rect.size)): return True

    cornerDistance_sq = (sphereXDistance - rect.size)**2 + (sphereYDistance - rect.size)**2 + (sphereZDistance - rect.size)**2

    return (cornerDistance_sq <= (sphere.radius**2))




#Ich habe sogar den ini reader selbst programmiert!
#Ich habe absichtlich kein # in Zeilen implementiert da es sonst Probleme geben würde wenn der Pfad ein # enhalten würde.
#Jedoch gehen # an Zeilenanfänge da diese dann einfach nicht erkannt und somit übersprungen werden.
print "Reading config.ini file"
Config_Error_1="Error in config.ini File Line:"
Config_Error_2="can only be true or false. To not interrupt the programmstart it was automatically set to"

Load_ConfigFile()

infoObject = pygame.display.Info()
if(Screen_width<100): Screen_width=infoObject.current_w
if(Screen_hight<100): Screen_hight=infoObject.current_h
os.environ['SDL_VIDEO_CENTERED'] = '1'

Loading_key()

#import and execute Update
import updater

Loading_key()
#Initialize the display module, hide the mouse and set the title image
print "Initialize pygame"
pygame.init()
pygame.mouse.set_visible(False)

#Set volumes
pygame.mixer.music.set_volume(Music_volume/100.0)
for bom in boom:
    bom.set_volume(Effect_volume/100.0)
GetHeart.set_volume(Effect_volume/100.0)
GetClock.set_volume(Effect_volume/100.0)
baem.set_volume(Effect_volume/100.0)

#Play a random backgrund sound
pygame.mixer.init(size=-16, channels=2, buffer=4096)
pygame.mixer.music.load(Sound[random.randint(0,2)]) #random.randint(1,2)
pygame.mixer.music.play(-1)

System_Icon = pygame.image.load("./Data/img/FM_Icon.ico")
pygame.display.set_icon(System_Icon)
screen = pygame.display.set_mode((Screen_width, Screen_hight))
screen.fill((255,255,255))
Font_ALGER_64 = pygame.font.Font(os.path.join("Data","Fonts","Algerian.ttf"),64)
label = Font_ALGER_64.render("Loading Objects wait some seconds", 1, (0,0,0))
screen.blit(label, ((Screen_width/2)-590, Screen_hight-80))
Titleimage = pygame.image.load("./Data/img/NicoIcon.png")
imagerect = Titleimage.get_rect()
if(Screen_width>Screen_hight-120):
    screen.blit(pygame.transform.scale(Titleimage, (Screen_hight-100, Screen_hight-120)), ((Screen_width-Screen_hight+120)/2, 20))
else:
    screen.blit(pygame.transform.scale(Titleimage, (Screen_width, Screen_width)), (0, 0))
pygame.display.flip()


#Preparing some Variables for the later use. The difference between the global variables on the top of the program is that this has to to with grafic or FPS
speed=1
frame_time=time.clock()
frame_time_alt=time.clock()

random.seed(time.clock())
Screen = (Screen_width,Screen_hight)
Cube_speed_z=[0.06,0.06,0.065,0.07,0.075,0.08,0.085,0.09,0.1,0.12,0.14]
r=0
GenerateNewArea_Schutzzeit=0
Window = glLibWindow(Screen,Fullscreen,System_Icon,"Float Motion - Nico Bosshard",False)
View3D = glLibView3D((0,0,Screen[0],Screen[1]),45)


glLibTexturing(True)
Camera = glLibCamera([0,0.5,6],[0,0,0])

glLibLighting(False)
Sun = glLibLight([20,200,20],Camera)
Sun.enable()
#glLibShadowInit([[512,5]])

glLibColorMaterial(True)

drawing = 0
#Objects = [glLibObjCube(),glLibObjTeapot(),glLibObjSphere(64),glLibObjCylinder(0.5,1.0,64),glLibObjCone(0.5,1.8,64),glLibObjFromFile("./Data/obj/Tunnel.obj")]

#Load the Font Algerian.ttf
print "Loading Fonts"
Font_ALGER_100 = pygame.font.Font(os.path.join("Data","Fonts","Algerian.TTF"),100)

#Generate some Texts.
print "Generate some Texts"
Floatmotion_Text = glLibObjText("Floatmotion",Font_ALGER_100,(200,200,200))
Programmer_Text = glLibObjText("Programmer",Font_ALGER_100,(255,255,128))
NicoBosshard_Text = glLibObjText("Nico Bosshard",Font_ALGER_100,(128,255,66))

Start_Z1_Text = glLibObjText("Pres a key",Font_ALGER_100,(255,255,0))
Start_Z2_Text = glLibObjText("to Start",Font_ALGER_100,(255,255,0))
Help_Text = glLibObjText("Press F1 for Help",Font_ALGER_100,(255,200,0))

Pause_Text = glLibObjText("Pause",Font_ALGER_100,(255,255,0))
Pause_Resume_Text = glLibObjText("Resume with any key",Font_ALGER_100,(255,200,0))
Pause_Ready = glLibObjText("Ready",Font_ALGER_100,(255,200,0))
Pause_GO = glLibObjText("GO",Font_ALGER_100,(0,255,0))

Pause_Leap_not_connected_Z1_peripheral_Text = glLibObjText("Please connect",Font_ALGER_100,(200,255,0))
Pause_Leap_not_connected_Z2_peripheral_Text = glLibObjText("Leap Motion Controller",Font_ALGER_100,(200,255,0))
Pause_Leap_not_connected_Z1_embedded_Text = glLibObjText("Activate Leap Motion",Font_ALGER_100,(200,255,0))
Pause_Leap_not_connected_Z2_embedded_Text = glLibObjText("Controller: Fn+Spacebar",Font_ALGER_100,(200,255,0))
Pause_Leap_not_connected_Z3_Text = glLibObjText("or press any key to",Font_ALGER_100,(200,255,0))
Pause_Leap_not_connected_Z4_Text = glLibObjText("resume in Mouse Mode",Font_ALGER_100,(200,255,0))

Pause_Hands_out_of_View_Z1_Text = glLibObjText("Hand out of view",Font_ALGER_100,(200,255,0))
Pause_Hands_out_of_View_Z2_Text = glLibObjText("Put it back or",Font_ALGER_100,(200,255,0))
Pause_Hands_out_of_View_Z3_Text = glLibObjText("press any key to",Font_ALGER_100,(200,255,0))
Pause_Hands_out_of_View_Z4_Text = glLibObjText("resume in Mouse Mode",Font_ALGER_100,(200,255,0))

Death_Game = glLibObjText("Game",Font_ALGER_100,(200,250,70))
Death_Over = glLibObjText("Over",Font_ALGER_100,(255,220,60))

BossCube_Level = glLibObjText("Level",Font_ALGER_100,(255,200,0))
#BossCube_Up = glLibObjText("Up",Font_ALGER_100,(180,230,30))
BossCube_Up = glLibObjText("Up",Font_ALGER_100,(255,230,30))

EndlessMode_Endless=glLibObjText("Endless",Font_ALGER_100,(64,128,255))
EndlessMode_Normal=glLibObjText("Normal",Font_ALGER_100,(64,255,64))
EndlessMode_Mode=glLibObjText("Mode",Font_ALGER_100,(255,200,0))

Leap_device_Text1=glLibObjText("Leap Motion",Font_ALGER_100,(64,128,255))
Leap_device_Text2v=glLibObjText("Controller",Font_ALGER_100,(128,64,255))
Leap_device_Text2t=glLibObjText("Controller",Font_ALGER_100,(64,150,150))
Leap_device_connected=glLibObjText("connected",Font_ALGER_100,(0,255,0))
Leap_device_disconnected=glLibObjText("disconnected",Font_ALGER_100,(255,64,0))


Font_LibSansB_100 = pygame.font.Font(os.path.join("Data","Fonts","LiberationSans-Bold.ttf"),100)
TutorialText=[]

print "Loading TutorialText"
for i in range(12):
    TutorialText.append([])

TutorialText[0].append(glLibObjText("Floatmotion",Font_ALGER_100,(255,128,64)))
TutorialText[0].append(glLibObjText("Tutorial",Font_ALGER_100,(64,128,255)))

#(random.randint(100,255),random.randint(100,255),random.randint(100,255))))
Tutorial_Color=(64,128,255)
TutorialText[1].append(glLibObjText("Use the Leap Motion Controller,",Font_LibSansB_100,Tutorial_Color))
TutorialText[1].append(glLibObjText("mouse or touchscreen to move.",Font_LibSansB_100,Tutorial_Color))
TutorialText[1].append(glLibObjText("Scrolling=Z-moving",Font_LibSansB_100,Tutorial_Color))
TutorialText[1].append(glLibObjText("Click the mouse to prioritize it",Font_LibSansB_100,Tutorial_Color))
TutorialText[1].append(glLibObjText("Q activate and priorize the keyboard",Font_LibSansB_100,Tutorial_Color))

TutorialText[2].append(glLibObjText("Try to avoid hitting the cubes",Font_LibSansB_100,Tutorial_Color))

TutorialText[3].append(glLibObjText("Collect hearts to get lives",Font_LibSansB_100,Tutorial_Color))

TutorialText[4].append(glLibObjText("Collect blue clocks to slow down",Font_LibSansB_100,Tutorial_Color))
TutorialText[4].append(glLibObjText("the game by 20%",Font_LibSansB_100,Tutorial_Color))

TutorialText[5].append(glLibObjText("Collect yellow clocks to speed up",Font_LibSansB_100,Tutorial_Color))
TutorialText[5].append(glLibObjText("the game by 20%",Font_LibSansB_100,Tutorial_Color))

TutorialText[6].append(glLibObjText("The RainbowCube make yourself",Font_LibSansB_100,Tutorial_Color))
TutorialText[6].append(glLibObjText("immortal for some seconds",Font_LibSansB_100,Tutorial_Color))

TutorialText[7].append(glLibObjText("Pause and resume the game",Font_LibSansB_100,Tutorial_Color))
TutorialText[7].append(glLibObjText("with the SPACE key",Font_LibSansB_100,Tutorial_Color))

TutorialText[8].append(glLibObjText("Use ESC to goto the Menu",Font_LibSansB_100,Tutorial_Color))
TutorialText[8].append(glLibObjText("and Alt & F4 to close",Font_LibSansB_100,Tutorial_Color))
TutorialText[8].append(glLibObjText("the game immediately",Font_LibSansB_100,Tutorial_Color))

TutorialText[9].append(glLibObjText("Level select with 1-0 key",Font_LibSansB_100,Tutorial_Color))
TutorialText[9].append(glLibObjText("Toggle Endless mode with E",Font_LibSansB_100,Tutorial_Color))

TutorialText[10].append(glLibObjText("Other important keys and",Font_LibSansB_100,Tutorial_Color))
TutorialText[10].append(glLibObjText("Cheats will you find",Font_LibSansB_100,Tutorial_Color))
TutorialText[10].append(glLibObjText("under Menu => Help",Font_LibSansB_100,Tutorial_Color))

TutorialText[11].append(glLibObjText("The big BossCube brings you up",Font_LibSansB_100,Tutorial_Color))
TutorialText[11].append(glLibObjText("to the next Level or to the End",Font_LibSansB_100,Tutorial_Color))


#Create Objects and Load *.obj and Textures for the later use.
Player = glLibObjTexSphere(0.3,64,0,0,2)
Texture_Player = glLibTexture("./Data/textures/Limeston.bmp")
Texture_NicoMenu3dLoch = glLibTexture("./Data/textures/FormatFactorynaturstein_marmor_weiss.bmp")

#BGround = glLibObjFromFile("./Data/obj/leer.obj")
Loading_key()
print "Loading ./Data/obj/NicoIcon.obj"
NicoIcon = glLibObjFromFile("./Data/obj/NicoIcon.obj")
Loading_key()
print "Loading ./Data/obj/Star.obj"
Star_obj = glLibObjFromFile("./Data/obj/Star.obj")
Loading_key()
print "Loading ./Data/obj/Heart.obj"
Heart_obj = glLibObjFromFile("./Data/obj/Heart.obj")
Loading_key()
print "Loading ./Data/obj/Clock.obj"
Clock_obj = glLibObjFromFile("./Data/obj/Clock.obj")
Loading_key()

print "Loading main menu"
cursor = glLibObjFromFile("./Data/obj/webhand.obj")
MenuPlatte = glLibObjFromFile("./Data/obj/NicoMenu3dLoch.obj")
MenuPilaster = glLibObjFromFile("./Data/obj/NicoMenuPilaster.obj")
MenuB1 = glLibObjFromFile("./Data/obj/NicoMenuB1.obj")
MenuB2 = glLibObjFromFile("./Data/obj/NicoMenuB2.obj")
MenuB3 = glLibObjFromFile("./Data/obj/NicoMenuB3.obj")
MenuB4 = glLibObjFromFile("./Data/obj/NicoMenuB4.obj")
MenuB5 = glLibObjFromFile("./Data/obj/NicoMenuB5.obj")

print "Generate NicoIcon particles"
glLibNicoIcon_Particles = []
for i in range(100):
    x=random.uniform(-1,1)
    y=random.uniform(-1,1)
    magnitude  = sqrt(x**2 + y**2)
    glLibNicoIcon_Particles.append(glLibNicoIcon(random.uniform(0.1,0.2),0,0,x/magnitude/random.uniform(45,75), y/magnitude/random.uniform(45,75),0,0,0))

#And the last thing before the main Loop
#glClearColor( 1, 1, 1, 1)
glLibTexturing(True)
glEnable(GL_DEPTH_TEST)
#glDisable(GL_DEPTH_TEST)

print "Loading finish"


#If NicoIcon_Show is set to true in the config.file the lead cutscene will be shown
if(NicoIcon_Show==True):
    import lead

glLibSelectTexture(Texture_NicoMenu3dLoch)
#Import the menu model
import menu

#Set the viewport for the Statusbar
Statusbar_Camera = glLibCamera([0,0,0],[0,0,1])
Statusbar_Sun = glLibLight([0,0,20],Camera)
Statusbar_Sun.enable()


#Menu loop
while True:
    Menu_button_clicked=menu.menu_show()

    Statusbar_hight=int(round(Screen[0]/17.5))
    View3D = glLibView3D((0,0,Screen[0],Screen[1]-Statusbar_hight),45)
    Statusbar = glLibView3D((0,Screen[1]-Statusbar_hight,Screen[0],Statusbar_hight),45)

    glLibTexturing(True)
    glLibSelectTexture(Texture_Player)

    LeapConnected_alt=LeapConnected
    LeapConnected_ShowText=0
    Start_ask_for_Leap=Leap_Pause_on_disconnect*40


    if(Menu_button_clicked==0):
        Tutorial=False
        import mainloop
        del sys.modules["mainloop"]
    elif(Menu_button_clicked==1):
        Tutorial=True
        Level=0
        import mainloop
        del sys.modules["mainloop"]
    elif(Menu_button_clicked==2):
        print "Opening Help.mht file"
        webbrowser.open("Help.mht")
        #webbrowser.open_new("file:///"+os.path.abspath('./Help.mht')) #Not Windows 7 Internet Explorer compatible
        MousePressed=pygame.mouse.get_pressed()
        while(MousePressed[0]!=False or MousePressed[1]!=False or MousePressed[2]!=False):
            Cutscene_key()
            time.sleep(0.05)
            MousePressed=pygame.mouse.get_pressed()
        continue
    elif(Menu_button_clicked==3):
        Settings_open()
    else:
        pygame.quit()
        sys.exit()


    View3D = glLibView3D((0,0,Screen[0],Screen[1]),45)
    Window.clear()

    View3D.set_view()
    Camera.set_camera()
    Sun.draw()

    glLibTexturing(True)
    glLibSelectTexture(Texture_Player)



